local COMBAT_EVENTS = {
	["SWING_DAMAGE"] = "DAMAGE",
	["RANGE_DAMAGE"] = "DAMAGE",
	["SPELL_DAMAGE"] = "DAMAGE",
	["SPELL_PERIODIC_DAMAGE"] = "DAMAGE",
	["ENVIRONMENTAL_DAMAGE"] = "DAMAGE",
	["DAMAGE_SHIELD"] = "DAMAGE",
	["DAMAGE_SPLIT"] = "DAMAGE",
	["SPELL_HEAL"] = "HEAL",
	["SPELL_PERIODIC_HEAL"] = "HEAL",
	["SWING_MISSED"] = "MISS",
	["RANGE_MISSED"] = "MISS",
	["SPELL_MISSED"] = "MISS",
	["SPELL_PERIODIC_MISSED"] = "MISS",
	["DAMAGE_SHIELD_MISSED"] = "MISS",
	["SPELL_DRAIN"] = "DRAIN",
	["SPELL_LEECH"] = "DRAIN",
	["SPELL_PERIODIC_DRAIN"] = "DRAIN",
	["SPELL_PERIODIC_LEECH"] = "DRAIN",
	["SPELL_ENERGIZE"] = "POWER",
	["SPELL_PERIODIC_ENERGIZE"] = "POWER",
	["SPELL_INTERRUPT"] = "INTERRUPT",
	["PARTY_KILL"] = "DEATH",
	["UNIT_DIED"] = "DEATH",
	["UNIT_DESTROYED"] = "DEATH",
	["SPELL_AURA_REFRESH"] = "BUFF",
	["SPELL_AURA_APPLIED"] = "BUFF",
	["SPELL_PERIODIC_AURA_REFRESH"] = "BUFF",
	["SPELL_PERIODIC_AURA_APPLIED"] = "BUFF",
	["SPELL_AURA_APPLIED_DOSE"] = "BUFF",
	["SPELL_PERIODIC_AURA_APPLIED_DOSE"] = "BUFF",
	["SPELL_AURA_REMOVED"] = "FADE",
	["SPELL_PERIODIC_AURA_REMOVED"] = "FADE",
	["SPELL_AURA_REMOVED_DOSE"] = "FADE",
	["SPELL_PERIODIC_AURA_REMOVED_DOSE"] = "FADE",
	["ENCHANT_APPLIED"] = "ENCHANT_APPLIED",
	["ENCHANT_REMOVED"] = "ENCHANT_REMOVED",
	["SPELL_SUMMON"] = "SUMMON",
	["SPELL_CREATE"] = "SUMMON",
	["SPELL_CAST_SUCCESS"] = "SUCCESS",
	["SPELL_CAST_START"] = "SPELLSTART",
}
function pootpoot:GetWarlockDefaults()
	local warlockdefaults = {
		profile = {
			curseofshadow = "Curse of Shadow!",	--Warlock Spells
			curseofshadowtgl = true,
			curseofshadowchance = 1,
			shadowbolt = "Shadow Bolt!",	-- Castable.
			shadowbolttgl = false,
			shadowboltcrit = true,
			shadowboltchance = 1,
			shadowboltcast = "Casting Shadow Bolt!",
			shadowboltcasttgl = true,
			shadowboltcastchance = 1,
			corruption = "Corruption!",	-- Castable if talented.
			corruptiontgl = true,
			corruptionchance = 1,
			immolate = "Immolate!",	-- Castable.
			immolatetgl = false,
			immolatecrit = true,
			immolatechance = 1,
			immolatecast = "Casting Immolate!",
			immolatecasttgl = true,
			immolatecastchance = 1,
			shadowburn = "Shadowburn!",
			shadowburntgl = true,
			shadowburncrit = true,
			shadowburnchance = 1,
			deathcoil = "Death Coil!",
			deathcoiltgl = true,
			deathcoilcrit = false,
			deathcoilchance = 1,
			howlofterror = "Howl of Terror!",	-- Castable.
			howlofterrortgl = true,
			howlofterrorchance = 1,
			curseofagony = "Curse of Agony!",
			curseofagonytgl = true,
			curseofagonychance = 1,
			lifetap = "Life Tap!",
			lifetaptgl = true,
			lifetapchance = 1,
			hellfire = "Hellfire!",	-- Channeled.
			hellfiretgl = true,
			hellfirechance = 1,
			incinerate = "Incinerate!",	-- Castable.
			incineratetgl = true,
			incineratecrit = true,
			incineratechance = 1,
			incineratecast = "Casting Incinerate!",
			incineratecasttgl = true,
			incineratecastchance = 1,
			curseofweakness = "Curse of Weakness!",
			curseofweaknesstgl = true,
			curseofweaknesschance = 1,
			curseofrecklessness = "Curse of Recklessness!",
			curseofrecklessnesstgl = true,
			curseofrecklessnesschance = 1,
			curseoftongues = "Curse of Tongues!",
			curseoftonguestgl = true,
			curseoftongueschance = 1,
			curseofdoom = "Curse of Doom!",
			curseofdoomtgl = true,
			curseofdoomchance = 1,
			seedofcorruption = "Seed of Corruption!",	-- Castable.
			seedofcorruptiontgl = true,
			seedofcorruptionchance = 1,
			banish = "Banishing %t!",	-- Castable.
			banishtgl = true,
			banishchance = 1,
			fear = "Fearing %t!",	-- Castable.
			feartgl = true,
			fearchance = 1,
			unstableaffliction = "Unstable Affliction!",
			unstableafflictiontgl = true,
			unstableafflictionchance = 1,
			siphonlife = "Siphon Life!",
			siphonlifetgl = true,
			siphonlifechance = 1,
			dreadsteed = "Summoning Dreadsteed!",
			dreadsteedtgl = true,
			dreadsteedchance = 1,
			haunt = "Haunt!",
			haunttgl = true,
			hauntcrit = true,
			hauntchance = 1,
			metamorphosis = "Metamorphosis!",
			metamorphosistgl = true,
			metamorphosischance = 1,
			chaosbolt = "Chaos Bolt!",	-- Castable.
			chaosbolttgl = false,
			chaosboltcrit = true,
			chaosboltchance = 1,
			chaosboltcast = "Casting Chaos Bolt!",
			chaosboltcasttgl = true,
			chaosboltcastchance = 1,
			shadowflame = "Shadowflame!",
			shadowflameburptgl = true,
			shadowflamechance = 1,
			summonfelhunter = "Summoning Felhunter!",
			summonfelhuntertgl = true,
			summonfelhunterchance = 1,
			summonimp = "Summoning Imp!",
			summonimptgl = true,
			summonimpchance = 1,
			summonsuccubus = "Summoning Succubus!",
			summonsuccubustgl = true,
			summonsuccubuschance = 1,
			summonvoidwalker = "Summoning Voidwalker!",
			summonvoidwalkertgl = true,
			summonvoidwalkerchance = 1,
			summonfelguard = "Summoning Felguard!",
			summonfelguardtgl = true,
			summonfelguardchance = 1,
			soulstone = "Soulstoning %t.",
			soulstonetgl = true,
			soulstonechance = 1,
		}
	}
	return warlockdefaults
end

function pootpoot:ParseWarlockCombat(arg1, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)
	local etype = COMBAT_EVENTS[event]
	local healtot, healamt, parent
	local amount, overDamage, school, resisted, blocked, absorbed, critical, glancing, crushing
	local spellId, spellName, spellSchool, missType, powerType, extraAmount, environmentalType, extraSpellId, extraSpellName, extraSpellSchool, auraType, overHeal
	local text, texture, message, inout, color

	if not self.db.profile.enabled then
		return
	end

	if zoneenable == false then
		return
	end

  	if not etype then
  		return
  	end

	local fromPlayer, fromPet
	if (sourceName and not CombatLog_Object_IsA(sourceFlags, COMBATLOG_OBJECT_NONE) ) then
		fromPlayer = CombatLog_Object_IsA(sourceFlags, COMBATLOG_FILTER_MINE)
	end
	if (destName and not CombatLog_Object_IsA(destFlags, COMBATLOG_OBJECT_NONE) ) then
		toPlayer = CombatLog_Object_IsA(destFlags, COMBATLOG_FILTER_MINE)
		toTarget = CombatLog_Object_IsA(destFlags, COMBATLOG_OBJECT_TARGET)
	end

	--if not from player or pet, then end
	if fromPlayer then
		if etype == "DAMAGE" then
			if event == "SWING_DAMAGE" then
				amount, overDamage, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...)
			else
				spellId, spellName, spellSchool, amount, overDamage, school, resisted, blocked, absorbed, critical, glancing, crushing = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
			end
			text = tostring(amount)
			if event == "SPELL_DAMAGE" then
				if spellName == "Shadow Bolt" then
					if (self.db.profile.shadowbolttgl) then
						if (self.db.profile.shadowboltcrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.shadowboltchance*100)) then
									self:DispPootMsg( self.db.profile.shadowbolt, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.shadowboltchance*100)) then
							self:DispPootMsg( self.db.profile.shadowbolt, "SAY" )
						end
					end
				elseif spellName == "Death Coil" and spellId ~= 47632 then
					if (self.db.profile.deathcoiltgl) then
						if (self.db.profile.deathcoilcrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.deathcoilchance*100)) then
									self:DispPootMsg( self.db.profile.deathcoil, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.deathcoilchance*100)) then
							self:DispPootMsg( self.db.profile.deathcoil, "SAY" )
						end
					end
				elseif spellName == "Shadowburn" then
					if (self.db.profile.shadowburntgl) then
						if (self.db.profile.shadowburncrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.shadowburnchance*100)) then
									self:DispPootMsg( self.db.profile.shadowburn, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.shadowburnchance*100)) then
							self:DispPootMsg( self.db.profile.shadowburn, "SAY" )
						end
					end
				elseif spellName == "Immolate" then
					if (self.db.profile.immolatetgl) then
						if (self.db.profile.immolatecrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.immolatechance*100)) then
									self:DispPootMsg( self.db.profile.immolate, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.immolatechance*100)) then
							self:DispPootMsg( self.db.profile.immolate, "SAY" )
						end
					end
				elseif spellName == "Incinerate" then
					if (self.db.profile.incineratetgl) then
						if (self.db.profile.incineratecrit) then
							if (critical) then
								if (math.random(100) <= (self.db.profile.incineratechance*100)) then
									self:DispPootMsg( self.db.profile.incinerate, "SAY" )
								end
							end
						elseif (math.random(100) <= (self.db.profile.incineratechance*100)) then
							self:DispPootMsg( self.db.profile.incinerate, "SAY" )
						end
					end
				end
			end
		elseif etype == "SUCCESS" then
			if event == "SPELL_CAST_SUCCESS" then
				spellId, spellName, spellSchool = select(1, ...)
				if spellName == "Life Tap" then
					if (self.db.profile.lifetaptgl) then
						if (math.random(100) <= (self.db.profile.lifetapchance*100)) then
							self:DispPootMsg( self.db.profile.lifetap, "SAY" )
						end
					end
				elseif spellName == "Curse of Shadow" then
					if (self.db.profile.curseofshadowtgl) then
						if (math.random(100) <= (self.db.profile.curseofshadowchance*100)) then
							self:DispPootMsg( self.db.profile.curseofshadow, "SAY" )
						end
					end
				elseif spellName == "Corruption" then
					if (self.db.profile.corruptiontgl) then
						if (math.random(100) <= (self.db.profile.corruptionchance*100)) then
							self:DispPootMsg( self.db.profile.corruption, "SAY" )
						end
					end
				elseif spellName == "Curse of Agony" then
					if (self.db.profile.curseofagonytgl) then
						if (math.random(100) <= (self.db.profile.curseofagonychance*100)) then
							self:DispPootMsg( self.db.profile.curseofagony, "SAY" )
						end
					end
				elseif spellName == "Hellfire" then
					if (self.db.profile.hellfiretgl) then
						if (math.random(100) <= (self.db.profile.hellfirechance*100)) then
							self:DispPootMsg( self.db.profile.hellfire, "SAY" )
						end
					end
				elseif spellName == "Curse of Weakness" then
					if (self.db.profile.curseofweaknesstgl) then
						if (math.random(100) <= (self.db.profile.curseofweaknesschance*100)) then
							self:DispPootMsg( self.db.profile.curseofweakness, "SAY" )
						end
					end
				elseif spellName == "Curse of Recklessness" then
					if (self.db.profile.curseofrecklessnesstgl) then
						if (math.random(100) <= (self.db.profile.curseofrecklessnesschance*100)) then
							self:DispPootMsg( self.db.profile.curseofrecklessness, "SAY" )
						end
					end
				elseif spellName == "Curse of Tongues" then
					if (self.db.profile.curseoftonguestgl) then
						if (math.random(100) <= (self.db.profile.curseoftongueschance*100)) then
							self:DispPootMsg( self.db.profile.curseoftongues, "SAY" )
						end
					end
				elseif spellName == "Curse of Doom" then
					if (self.db.profile.curseofdoomtgl) then
						if (math.random(100) <= (self.db.profile.curseofdoomchance*100)) then
							self:DispPootMsg( self.db.profile.curseofdoom, "SAY" )
						end
					end
				elseif spellName == "Howl of Terror" then
					if (self.db.profile.howlofterrortgl) then
						if (math.random(100) <= (self.db.profile.howlofterrorchance*100)) then
							self:DispPootMsg( self.db.profile.howlofterror, "SAY" )
						end
					end
				elseif spellName == "Siphon Life" then
					if (self.db.profile.siphonlifetgl) then
						if (math.random(100) <= (self.db.profile.siphonlifechance*100)) then
							self:DispPootMsg( self.db.profile.siphonlife, "SAY" )
						end
					end
				elseif spellName == "Shadowflame" then
					if (self.db.profile.shadowflametgl) then
						if (math.random(100) <= (self.db.profile.shadowflamechance*100)) then
							if (self.db.profile.shadowflameburptgl) then
								DoEmote("burp",1)
							else
								self:DispPootMsg( self.db.profile.shadowflame, "SAY" )
							end
						end
					end
				end
			end
		elseif etype == "MISS" then
			if event == "SPELL_MISSED" then
				spellId, spellName, spellSchool, missType, amountMissed  = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
			end
		elseif etype == "SPELLSTART" then
			if event == "SPELL_CAST_START" then
				spellId, spellName, spellSchool = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
				if spellName == "Banish" then
					if (self.db.profile.banishtgl) then
						if (math.random(100) <= (self.db.profile.banishchance*100)) then
							self:DispPootMsg( self.db.profile.banish, "SAY" )
						end
					end
				elseif spellName == "Fear" then
					if (self.db.profile.feartgl) then
						if (math.random(100) <= (self.db.profile.fearchance*100)) then
							self:DispPootMsg( self.db.profile.fear, "SAY" )
						end
					end
				elseif spellName == "Howl of Terror" then
					if (self.db.profile.howlofterrortgl) then
						if (math.random(100) <= (self.db.profile.howlofterrorchance*100)) then
							self:DispPootMsg( self.db.profile.howlofterror, "SAY" )
						end
					end
				elseif spellName == "Seed of Corruption" then
					if (self.db.profile.seedofcorruptiontgl) then
						if (math.random(100) <= (self.db.profile.seedofcorruptionchance*100)) then
							self:DispPootMsg( self.db.profile.seedofcorruption, "SAY" )
						end
					end
				elseif spellName == "Shadow Bolt" then
					if (self.db.profile.shadowboltcasttgl) then
						if (math.random(100) <= (self.db.profile.shadowboltcastchance*100)) then
							self:DispPootMsg( self.db.profile.shadowboltcast, "SAY" )
						end
					end
				elseif spellName == "Immolate" then
					if (self.db.profile.immolatecasttgl) then
						if (math.random(100) <= (self.db.profile.immolatecastchance*100)) then
							self:DispPootMsg( self.db.profile.immolatecast, "SAY" )
						end
					end
				elseif spellName == "Incinerate" then
					if (self.db.profile.incineratecasttgl) then
						if (math.random(100) <= (self.db.profile.incineratecastchance*100)) then
							self:DispPootMsg( self.db.profile.incineratecast, "SAY" )
						end
					end
				elseif spellName == "Unstable Affliction" then
					if (self.db.profile.unstableafflictiontgl) then
						if (math.random(100) <= (self.db.profile.unstableafflictionchance*100)) then
							self:DispPootMsg( self.db.profile.unstableaffliction, "SAY" )
						end
					end
				elseif spellName == "Dreadsteed" then
					if (self.db.profile.dreadsteedtgl) then
						if (math.random(100) <= (self.db.profile.dreadsteedchance*100)) then
							self:DispPootMsg( self.db.profile.dreadsteed, "SAY" )
						end
					end
				elseif spellName == "Summon Felhunter" then
					if (self.db.profile.summonfelhuntertgl) then
						if (math.random(100) <= (self.db.profile.summonfelhunterchance*100)) then
							self:DispPootMsg( self.db.profile.summonfelhunter, "SAY" )
						end
					end
				elseif spellName == "Summon Imp" then
					if (self.db.profile.summonimptgl) then
						if (math.random(100) <= (self.db.profile.summonimpchance*100)) then
							self:DispPootMsg( self.db.profile.summonimp, "SAY" )
						end
					end
				elseif spellName == "Summon Succubus" then
					if (self.db.profile.summonsuccubustgl) then
						if (math.random(100) <= (self.db.profile.summonsuccubuschance*100)) then
							self:DispPootMsg( self.db.profile.summonsuccubus, "SAY" )
						end
					end
				elseif spellName == "Summon Voidwalker" then
					if (self.db.profile.summonvoidwalkertgl) then
						if (math.random(100) <= (self.db.profile.summonvoidwalkerchance*100)) then
							self:DispPootMsg( self.db.profile.summonvoidwalker, "SAY" )
						end
					end
				elseif spellName == "Summon Felguard" then
					if (self.db.profile.summonfelguardtgl) then
						if (math.random(100) <= (self.db.profile.summonfelguardchance*100)) then
							self:DispPootMsg( self.db.profile.summonfelguard, "SAY" )
						end
					end
				end
			end
		elseif etype == "BUFF" then
			if event == "SPELL_AURA_APPLIED" then
				spellId, spellName, spellSchool, auraType = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
			end
		end
		if etype == "POWER" then
			--if event == "SPELL_ENERGIZE" then
			--	spellId, spellName, spellSchool, amount, powerType = select(1, ...)
			--	texture = select(3, GetSpellInfo(spellId))
			--end
		end
	elseif toPlayer then
		if etype == "BUFF" then
			if event == "SPELL_AURA_REFRESH" then
				spellId, spellName, spellSchool, auraType = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
			end
		end
	end
	if fromPlayer and toTarget then
		if destName then -- REDUNDANT?
			if event == "SPELL_AURA_APPLIED" then
				spellId, spellName, spellSchool, auraType = select(1, ...)
				texture = select(3, GetSpellInfo(spellId))
				if spellName == "Soulstone Resurrection" then
					if (self.db.profile.soulstonetgl) then
						if (math.random(100) <= (self.db.profile.soulstonechance*100)) then
							self:DispPootMsg( destName .. " has been Soulstoned.", "SAY" )
						end
					end
				end
			end
		end
	end
end